'use strict';
/*global self*/
/*jslint bitwise: true*/

//two's complement
self.checksum = function (value) {
  //console.log('checksum called:' + value);
  //var v = ~value & 255;
  //v += 1;
  var v = (~value + 1) & 255;
  return v;
};


self.timer = function () {
  setTimeout(function () {
    var i, j, len, line, address, nr_bytes, checksum, x, b, nbytes;
    var bytesCount = self.start;
    var end_line = ':00000001FF';
    while (self.data.length > 0) {
      self.percent = ((self.data_length - self.data.length) * 100 / self.data_length).toFixed(0);
      self.postMessage({progress: true, value: self.percent, data: self.buffer});
      line = '';
      address = bytesCount.toString(16);
      bytesCount += 16;
      //console.log('address.length:' + address.length);
      for (j = 0, len = (4 - address.length); j < len; j++) {
        //console.log('j:' + j);
        address = '0' + address;
      }
      //console.log('address:' + address);
      line += address + '00';  //record type is always zero
      nr_bytes = 0;
      checksum = 0;
      //add address bytes to checksum
      x = parseInt('0x' + address, 16);
      checksum += (x >> 8 & 255);
      checksum += (x & 255);
      for (i = 0; i < 16; i++) {
        //console.log('this is i:' + i);
        b = self.data.shift();
        if (b === undefined) {break; }
        //console.log('b:' + b);
        checksum += b;
        //console.log('checksum:' + checksum);
        b = b.toString(16);
        if (b.length < 2) {
          b = '0' + b;
        }
        line += b;
        //console.log(b);
        nr_bytes += 1;
      }
      checksum += nr_bytes;  //checksum is first byte with size (16) + sum of all data bytes
      checksum = self.checksum(checksum);
      //console.log('checksum:' + checksum + ":" + checksum.toString(16));
      checksum = checksum.toString(16);
      if (checksum.length < 2) { checksum = '0' + checksum; }
      line += checksum;
      nbytes = nr_bytes.toString(16);
      if (nbytes.length < 2) { nbytes = '0' + nbytes; }
      line = ':' + nbytes + line;
      line = line.toUpperCase();
      //console.log(line);
      self.output.push(line);
    }
    self.output.push(end_line);
    //console.log(self.output);
    self.postMessage({progress: false, value: self.percent, data: self.output});
  }, 1);
};

self.addEventListener('message', function (e) {
  console.log('IntelHex worker called');
  self.data = e.data.data;
  self.data_length = self.data.length;
  self.start = e.data.start;
  self.percent = 0;
  self.output = [];
  //start
  self.timer();
}, false);